// This file is generated by kconfig_compiler_kf6 from virtualdesktopssettings.kcfg.
// All changes you do to this file will be lost.
#ifndef VIRTUALDESKTOPSSETTINGS_H
#define VIRTUALDESKTOPSSETTINGS_H

#include <qglobal.h>
#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

class VirtualDesktopsSettings : public KConfigSkeleton
{
  Q_OBJECT
  public:

    VirtualDesktopsSettings( QObject *parent = nullptr );
    ~VirtualDesktopsSettings() override;

    /**
      Set Whether or not, we circle through the virtual desktop when moving from one to the next
    */
    void setRollOverDesktops( bool v )
    {
      if (v != mRollOverDesktops && !isRollOverDesktopsImmutable()) {
        mRollOverDesktops = v;
        Q_EMIT rollOverDesktopsChanged();
      }
    }

    Q_PROPERTY(bool rollOverDesktops READ rollOverDesktops WRITE setRollOverDesktops NOTIFY rollOverDesktopsChanged)
    Q_PROPERTY(bool isRollOverDesktopsImmutable READ isRollOverDesktopsImmutable CONSTANT)
    /**
      Get Whether or not, we circle through the virtual desktop when moving from one to the next
    */
    bool rollOverDesktops() const
    {
      return mRollOverDesktops;
    }

    /**
      Is Whether or not, we circle through the virtual desktop when moving from one to the next Immutable
    */
    bool isRollOverDesktopsImmutable() const
    {
      return isImmutable( QStringLiteral( "rollOverDesktops" ) );
    }

    /**
      Get Whether or not, we circle through the virtual desktop when moving from one to the next default value
    */
    bool defaultRollOverDesktopsValue() const
    {
        return defaultRollOverDesktopsValue_helper();
    }

    /**
      Set Display in an OSD the virtual desktop name when switching between virtual desktops
    */
    void setDesktopChangeOsdEnabled( bool v )
    {
      if (v != mDesktopChangeOsdEnabled && !isDesktopChangeOsdEnabledImmutable()) {
        mDesktopChangeOsdEnabled = v;
        Q_EMIT desktopChangeOsdEnabledChanged();
      }
    }

    Q_PROPERTY(bool desktopChangeOsdEnabled READ desktopChangeOsdEnabled WRITE setDesktopChangeOsdEnabled NOTIFY desktopChangeOsdEnabledChanged)
    Q_PROPERTY(bool isDesktopChangeOsdEnabledImmutable READ isDesktopChangeOsdEnabledImmutable CONSTANT)
    /**
      Get Display in an OSD the virtual desktop name when switching between virtual desktops
    */
    bool desktopChangeOsdEnabled() const
    {
      return mDesktopChangeOsdEnabled;
    }

    /**
      Is Display in an OSD the virtual desktop name when switching between virtual desktops Immutable
    */
    bool isDesktopChangeOsdEnabledImmutable() const
    {
      return isImmutable( QStringLiteral( "desktopChangeOsdEnabled" ) );
    }

    /**
      Get Display in an OSD the virtual desktop name when switching between virtual desktops default value
    */
    bool defaultDesktopChangeOsdEnabledValue() const
    {
        return defaultDesktopChangeOsdEnabledValue_helper();
    }

    /**
      Set Duraton of the OSD
    */
    void setPopupHideDelay( int v )
    {
      if (v != mPopupHideDelay && !isPopupHideDelayImmutable()) {
        mPopupHideDelay = v;
        Q_EMIT popupHideDelayChanged();
      }
    }

    Q_PROPERTY(int popupHideDelay READ popupHideDelay WRITE setPopupHideDelay NOTIFY popupHideDelayChanged)
    Q_PROPERTY(bool isPopupHideDelayImmutable READ isPopupHideDelayImmutable CONSTANT)
    /**
      Get Duraton of the OSD
    */
    int popupHideDelay() const
    {
      return mPopupHideDelay;
    }

    /**
      Is Duraton of the OSD Immutable
    */
    bool isPopupHideDelayImmutable() const
    {
      return isImmutable( QStringLiteral( "popupHideDelay" ) );
    }

    /**
      Get Duraton of the OSD default value
    */
    int defaultPopupHideDelayValue() const
    {
        return defaultPopupHideDelayValue_helper();
    }

    /**
      Set Whether or not to display desktop layout in the OSD
    */
    void setTextOnly( bool v )
    {
      if (v != mTextOnly && !isTextOnlyImmutable()) {
        mTextOnly = v;
        Q_EMIT textOnlyChanged();
      }
    }

    Q_PROPERTY(bool textOnly READ textOnly WRITE setTextOnly NOTIFY textOnlyChanged)
    Q_PROPERTY(bool isTextOnlyImmutable READ isTextOnlyImmutable CONSTANT)
    /**
      Get Whether or not to display desktop layout in the OSD
    */
    bool textOnly() const
    {
      return mTextOnly;
    }

    /**
      Is Whether or not to display desktop layout in the OSD Immutable
    */
    bool isTextOnlyImmutable() const
    {
      return isImmutable( QStringLiteral( "textOnly" ) );
    }

    /**
      Get Whether or not to display desktop layout in the OSD default value
    */
    bool defaultTextOnlyValue() const
    {
        return defaultTextOnlyValue_helper();
    }


    enum {
      signalRollOverDesktopsChanged = 1,
      signalDesktopChangeOsdEnabledChanged = 2,
      signalPopupHideDelayChanged = 3,
      signalTextOnlyChanged = 4
    };

  Q_SIGNALS:
    void rollOverDesktopsChanged();

    void desktopChangeOsdEnabledChanged();

    void popupHideDelayChanged();

    void textOnlyChanged();

  private:
    void itemChanged(quint64 signalFlag);

  protected:

    // Windows
    bool mRollOverDesktops;
    bool defaultRollOverDesktopsValue_helper() const;

    // Plugins
    bool mDesktopChangeOsdEnabled;
    bool defaultDesktopChangeOsdEnabledValue_helper() const;

    // Script-desktopchangeosd
    int mPopupHideDelay;
    int defaultPopupHideDelayValue_helper() const;
    bool mTextOnly;
    bool defaultTextOnlyValue_helper() const;

  private:
};

#endif

